package com.uas;

import com.uas.util.BaseUtil;
import com.uas.util.JdbcUtil;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.util.Date;

import static com.uas.main.Download.downloadRun;
import static com.uas.main.DownloadFilePath.runDownloadFilePath;
import static com.uas.main.Upload.uploadRun;

/**
 * @author koul
 * @date 2020-05-26
 */

@SpringBootApplication
@EnableScheduling
public class LhctApplication {

    public static void main(String[] args) {
        SpringApplication.run(LhctApplication.class, args);
    }

    @Scheduled(fixedRate=1000*60*5)
    public void ediSendAndReceive() {
        uploadRun();
        System.out.println("begin"+new Date());
        downloadRun();
        closeJdbc();
        System.out.println("run over!");
    }

    @Scheduled(fixedRate=1000*60*60)
    public void downloadFile() {
        System.out.println("begin download"+new Date());
        runDownloadFilePath();
        closeJdbc();
        System.out.println("download over!");
    }
    private void closeJdbc(){
        //关闭数据库连接
        try{
            if(JdbcUtil.connection!=null){
                JdbcUtil.connection.close();
            }
        }catch(Exception e){
            BaseUtil.getLogger().error(e.toString());
            e.printStackTrace();
        }finally{
            JdbcUtil.connection = null;
        }
    }
}
