package com.uas.util;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import java.io.IOException;
import java.util.Properties;


public class BaseUtil {
	public static Logger logger;
	
	/**
	 * 获取日志类
	 * @return 日志类
	 */
	public static Logger getLogger(){
		if(logger==null){
			logger = Logger.getLogger(BaseUtil.class);
		    //loger所需的配置文件路径   
			Properties prop = new Properties();
		    try {
				prop.load(BaseUtil.class.getResourceAsStream("/properties/log4j.properties"));
			} catch (IOException e) {
				e.printStackTrace();
			}
		    PropertyConfigurator.configure(prop); 
		}
		return logger;
	}
	
	public static void logDownload(String fileName,String ip,String downloadpath){
		getLogger().info("download " + fileName + " from " + ip + " path:" + downloadpath);
	}
}
